% SAMM 2017, exercise 2: optimal control of a pendulum on a cart with forcing
% by a Variational Integrator discretization (linear interpolation, m.p.-rule)
% 
% author: kathrin.flasskamp@uni-bremen.de
%
% [y] = D1Ld(q1,q2)
%
% function computes the partial derivative of Ld wrt first argument for
% pendulum on cart with q=(x,a)
%
% Input:  q1 left node, q2 right node
%
% Output: 2dim vector of partial derivative D1 Ld

function y = D1Ld(q1,q2)
    global mp;
    global mc;
    global l;
    global g;
    global h;

    m=mp+mc;
    Jtr=mp*l^2;
    
    
    Dx = q2(1) - q1(1);
    Da = q2(2) - q1(2);
    Sx = q1(1) + q2(1);
    Sa = q1(2) + q2(2);
    

    y(1,1) = -m/h*Dx + mp/h*l*sin(Sa/2)*Da;
    y(2,1) = -mp/h*l*cos(Sa/2)*Da/2*Dx + mp/h*l*sin(Sa/2)*Dx - mp/h*l^2*Da - h/2*mp*g*l*cos(Sa/2);
    
%     y(1,1) = -(m/h)*Dx + (mp/h)*l*Da*sin(Sa/2)
%     y(2,1) = (mp/h)*l*Dx*(sin(Sa/2)-(Da/2)*cos(Sa/2)) - (Jtr/h)*Da - (h/2)*mp*g*l*cos(Sa/2)
    
endfunction