% SAMM 2017, exercise 2: optimal control of a pendulum on a cart with forcing
% by a Variational Integrator discretization (linear interpolation, m.p.-rule)
% 
% author: kathrin.flasskamp@uni-bremen.de
%
% [p] = LegendreTrafo(q,v)
%
% computes continuous-time Legendre transformation. To be used for transforming
% boundary values of OCP.



function p = LegendreTrafo(q,v)

global mp=1;
global mc=0.5;
global l=0.1;


mass_matrix = [mp+mc, -mp*l*sin(q(2));
              -mp*l*sin(q(2)), mp*l^2];

p=mass_matrix*v;



endfunction